#include <extdll.h>			// always
#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc

#include "fakefull.h"

fakeclient_t fakeclient[32];
fake_t fake;

void AddFakeClient(const char* sName) {
	if (!sName) sName = "ff^client";
	edict_t*pEdict = CREATE_FAKE_CLIENT(sName);
	if (FNullEnt(pEdict))
		return;
	int index=ENTINDEX(pEdict);
	pFake = GET_PLAYER_I(index);
	pFake->jointime = gpGlobals->time + ((ff_delay->value + MINIMAL_DELAY) / 2.0);
	pFake->pEdict = pEdict;
	pFake->fake = true;
	CALL_GAME_ENTITY(PLID,"player",VARS(pEdict));
	char *sInfoBuffer=GET_INFOKEYBUFFER(pEdict);
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "rate", "3500");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "cl_updaterate", "20");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "cl_lw", "1");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "cl_lc", "1");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "cl_dlmax", "128");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "_vgui_menus", "0");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "_ah", "0");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "dm", "0");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "tracker", "0");
	SET_CLIENT_KEYVALUE(index, sInfoBuffer, "friends", "0");
	char szRejectReason[128];
	MDLL_ClientConnect( pEdict, sName, "127.0.0.1", szRejectReason );
	MDLL_ClientPutInServer( pEdict );
	//LOG_MESSAGE(PLID, "\"%s<%d><BOT><>\" triggered \"fakeclient\"", STRING(pEdict->v.netname) , GETPLAYERUSERID(pEdict) );
}

void AddName(){
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  ff_name < string >\n");
		return;
	}
	names_t*one=new names_t;
	one->name = new char[ strlen(CMD_ARGV(1)) +1 ];
	strcpy(one->name,CMD_ARGV(1));
	one->used = false;
	one->next = fake.names;
	fake.names = one;
	++fake.numnames;
}

void RemoveFakeClient(){
	if (!fake.numfakeplayers){
		SERVER_PRINT("No fakeclient to remove.\n");
		return;
	}
	for(int a = 1; a <= gpGlobals->maxClients; ++a){
		pFake = GET_PLAYER_I(a);
		if (pFake->fake){
			SERVER_COMMAND(UTIL_VarArgs("kick \"%s\"\n",STRING(pFake->pEdict->v.netname)));
			break;
		}
	}
}

char* UTIL_VarArgs( char *format, ... ){
	va_list		argptr;
	static char		string[1024];
	va_start (argptr, format);
	vsprintf (string, format,argptr);
	va_end (argptr);
	return string;
}

void UpdatePlayersNum(){
	fakeclient_t*pFake;
	fake.numplayers = 0; //and reset number of player connected to server
	fake.numfakeplayers = 0;
	for(int i = 1; i <= gpGlobals->maxClients; ++i){
		pFake = GET_PLAYER_I(i);
		if (pFake->pEdict&&STRING(pFake->pEdict->v.netname)[0]) {//if this slot has a name
			if (pFake->fake) 
				++fake.numfakeplayers;
			++fake.numplayers;
		}
	}
}

const char* PickUpName()
{
	if ( !fake.names ) {
		//LOG_ERROR(PLID, "Configuration file for fakefull was not loaded.")
		//LOG_ERROR(PLID, "Please copy fakefull.cfg to your game modification directory.");
		//LOG_ERROR(PLID, "Put \"exec fakefull.cfg\" to your \"server.cfg\" and \"listenserver.cfg\".");
		return NULL;
	}

	for (int i = 0; i < 16; ++i){
		names_t* s = fake.names;
		for (int j = RANDOM_LONG( 0, fake.numnames - 1 ); j ; --j )	{
			s = s->next;
		}
		if ( s->used ) continue;
		s->used = true;
		return s->name;
	}

	return NULL;
}