
#ifndef FAKEFULL_API_H
#define FAKEFULL_API_H

#include <enginecallback.h>		// ALERT()
#include <sdk_util.h>			// UTIL_VarArgs()
#include <api_info.h>
#include <meta_api.h>

#define FF_VERSION "1.3"

#define GET_PLAYER_I(a) (&fakeclient[a])
#define GET_PLAYER_E(a) (&fakeclient[ENTINDEX(a)])
 
struct fakeclient_t {
	bool fake;
	float jointime;
	edict_t* pEdict;
};

struct names_t {
	char* name;
	bool used;
	names_t* next;
};

struct fake_t {
	int	numfakeplayers;
	int	numplayers;
	int numnames;
	names_t* names;
	float checktime;
	float addtime;
};

extern fakeclient_t fakeclient[32];
extern fake_t		fake;
extern cvar_t		*ff_players;
extern cvar_t		*ff_delay;
extern fakeclient_t	*pFake;

void AddFakeClient(const char* szName);
void AddName();
void RemoveFakeClient();
void UpdatePlayersNum();
const char* PickUpName();

char* UTIL_VarArgs( char *format, ... );

#define CVAR_DIRSET_STRING		(*g_engfuncs.pfnCvar_DirectSet)
#define CLIENT_PRINT			(*g_engfuncs.pfnClientPrintf)
#define CREATE_FAKE_CLIENT		(*g_engfuncs.pfnCreateFakeClient)
#define RUNPLAYERMOVE			(*g_engfuncs.pfnRunPlayerMove)

void FAKE_CLIENT_COMMAND(edict_t *pEdict, const char *cmd, const char *arg1, const char *arg2);

#define MINIMAL_DELAY 0.2

#endif // FAKEFULL_API_H