#include <extdll.h>			// always
#include <meta_api.h>		// of course
#include <dllapi.h>
#include "sdk_util.h"		// UTIL_LogPrintf, etc
#include <h_export.h>
#include "fakefull.h"

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;
fakeclient_t* pFake;

cvar_t	*ff_players;
cvar_t	*ff_delay;
cvar_t	init_fakefull_version={"fakefull_version",FF_VERSION};
cvar_t	init_ff_players={"ff_players","8", 0, 8};
cvar_t	init_ff_delay={"ff_delay","0.2", 0, 0.2};

/*BOOL ClientConnect_Post( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  ){

	RETURN_META_VALUE(MRES_IGNORED, TRUE);
}*/

void ClientDisconnect_Post( edict_t *pEntity ) {
	fake.addtime = gpGlobals->time + ff_delay->value + MINIMAL_DELAY;
	pFake = GET_PLAYER_E(pEntity);
	if (pFake->fake) {
		pFake->fake = false; //uncheck him
		const char* name = STRING(pEntity->v.netname);
		for(names_t* s = fake.names; s ; s= s->next) //and uncheck name it had
			if (!strcmp(s->name,name)){
				s->used = false;
				break;
			}
	}
	RETURN_META(MRES_IGNORED);
}

void ClientPutInServer_Post( edict_t *pEntity ) {
	pFake = GET_PLAYER_E(pEntity);
	pFake->pEdict = pEntity;
	fake.addtime = gpGlobals->time + ff_delay->value + MINIMAL_DELAY;
	RETURN_META(MRES_IGNORED);
}

void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax ){
	fake.addtime = gpGlobals->time + ff_delay->value + MINIMAL_DELAY;
	RETURN_META(MRES_IGNORED);
}

void ServerDeactivate_Post( void ){
	fake.numfakeplayers = 0;
	fake.numplayers = 0;
	fake.addtime = 0.0;
	fake.numnames = 0;
	fake.checktime = 0.0;
	while(fake.names){
		names_t*todel=fake.names;
		fake.names = fake.names->next;
		delete[] todel->name;
		delete todel;
	}
	RETURN_META(MRES_IGNORED);
}

void StartFrame_Post( void ) {

	// if there was an ff_players change then apply it to current state of fake clients 
	if (fake.checktime < gpGlobals->time){
		fake.checktime = gpGlobals->time + 0.5;
		static int last_addnum = ff_players->value;
		if (last_addnum != ff_players->value){
			fake.addtime = gpGlobals->time + ff_delay->value + MINIMAL_DELAY;
			last_addnum = ff_players->value;
		}
	}

	if (fake.addtime && fake.addtime < gpGlobals->time)	{
		fake.addtime = 0.0;
		UpdatePlayersNum(); //update number of clients connected to server
		if (fake.numplayers < ff_players->value)	{
			fake.addtime = gpGlobals->time + ff_delay->value + MINIMAL_DELAY;
			AddFakeClient( PickUpName() );
		}
		else if (fake.numplayers > ff_players->value && fake.numfakeplayers) {
			fake.addtime = gpGlobals->time + ff_delay->value + MINIMAL_DELAY; //and check again	
			RemoveFakeClient();
		}
		if (fake.numplayers == gpGlobals->maxClients && ff_players->value > gpGlobals->maxClients){
			fake.addtime = 0.0; //don't try to add more bots if addnum is higher then maxplayers
		}
	}
	
	for(int a=1;a<=gpGlobals->maxClients;++a){
		pFake = GET_PLAYER_I(a);
		if (pFake->fake){
			pFake->pEdict->v.flags |= FL_FAKECLIENT; // flag him as fake client
			if (pFake->jointime>0&&pFake->jointime<gpGlobals->time){ //if time for joining the team then do that
				pFake->jointime = 0;
				FAKE_CLIENT_COMMAND(pFake->pEdict,"menuselect","6",NULL); //join to the spectators
				pFake->pEdict->v.frags = RANDOM_LONG(0,15); //and set random frags
			}
			RUNPLAYERMOVE(pFake->pEdict,pFake->pEdict->v.v_angle,0.0,0.0,0,0,0,76);
		}
	}

	RETURN_META(MRES_IGNORED);
}

struct fakecmd_t {
	char	args[1024];
	char	argv[3][512];
	int		argc;
	bool	fake;
} fakecmd;

void FAKE_CLIENT_COMMAND(edict_t *pEdict, const char *cmd, const char *arg1, const char *arg2) {
	if (cmd){
		fakecmd.fake = true;
		strcpy(fakecmd.argv[0],cmd);
		if (arg2){
			fakecmd.argc = 3;
			strcpy(fakecmd.argv[1],arg1);
			strcpy(fakecmd.argv[2],arg2);
			sprintf(fakecmd.args,"%s %s",arg1,arg2);
		}
		else if (arg1){
			fakecmd.argc = 2;
			fakecmd.argv[2][0] = 0;
			strcpy(fakecmd.argv[1],arg1);
			sprintf(fakecmd.args,"%s",arg1);
		}
		else {
			fakecmd.argc = 1;
			fakecmd.argv[1][0] = 0;
			fakecmd.argv[2][0] = 0;
		}
		MDLL_ClientCommand(pEdict);
		fakecmd.fake = false;
	}
}

const char *Cmd_Args( void ) {
	if (fakecmd.fake)
		RETURN_META_VALUE(MRES_SUPERCEDE, (fakecmd.argc>1)?(fakecmd.args):(NULL));
	else
		RETURN_META_VALUE(MRES_IGNORED, NULL);
}

const char *Cmd_Argv( int argc ) {
	if (fakecmd.fake)
		RETURN_META_VALUE(MRES_SUPERCEDE, (argc<3)?(fakecmd.argv[argc]):(""));
	else
		RETURN_META_VALUE(MRES_IGNORED, NULL);
}

int Cmd_Argc( void ) {
   if (fakecmd.fake)
      RETURN_META_VALUE(MRES_SUPERCEDE, fakecmd.argc );
   else
      RETURN_META_VALUE(MRES_IGNORED, 0);
}

// Must provide at least one of these..
static META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META; called after game DLL
	NULL,			// pfnGetEntityAPI2				HL SDK2; called before game DLL
	GetEntityAPI2_Post,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post	META; called after game DLL
	GetEngineFunctions,			// pfnGetEngineFunctions		META; called before HL engine
	NULL,			// pfnGetEngineFunctions_Post	META; called after HL engine
};

// Description of plugin
plugin_info_t Plugin_info = {
	META_INTERFACE_VERSION,	// ifvers
	"fakefull",	// name
	FF_VERSION,	// version
	"02/06/2002",	// date
	"OLO",	// author
	"http://www.olo.counter-strike.pl",	// url
	"FF",	// logtag
	PT_ANYPAUSE,// (when) loadable
	PT_ANYPAUSE,// (when) unloadable
};

// Global vars from metamod:
meta_globals_t *gpMetaGlobals;		// metamod globals
gamedll_funcs_t *gpGamedllFuncs;	// gameDLL function tables
mutil_funcs_t *gpMetaUtilFuncs;		// metamod utility functions

C_DLLEXPORT int Meta_Query(char *ifvers, plugin_info_t **pPlugInfo,	mutil_funcs_t *pMetaUtilFuncs) {
	*pPlugInfo=&Plugin_info;
	gpMetaUtilFuncs=pMetaUtilFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Attach(PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs) {
	gpMetaGlobals=pMGlobals;
	memcpy(pFunctionTable, &gMetaFunctionTable, sizeof(META_FUNCTIONS));
	gpGamedllFuncs=pGamedllFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Detach(PLUG_LOADTIME now, PL_UNLOAD_REASON reason) {
	return(TRUE);
}

void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals ) {
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;

	REG_SVR_COMMAND("ff_name", AddName);

	CVAR_REGISTER (&init_ff_players);
	CVAR_REGISTER (&init_ff_delay);
	CVAR_REGISTER (&init_fakefull_version);

	ff_players=CVAR_GET_POINTER("ff_players");
	ff_delay=CVAR_GET_POINTER("ff_delay");
}

DLL_FUNCTIONS gFunctionTable_Post;
C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable_Post.pfnClientDisconnect = ClientDisconnect_Post;
	//gFunctionTable_Post.pfnClientConnect = ClientConnect_Post;
	gFunctionTable_Post.pfnClientPutInServer = ClientPutInServer_Post;
	gFunctionTable_Post.pfnServerActivate = ServerActivate_Post;
	gFunctionTable_Post.pfnServerDeactivate = ServerDeactivate_Post;
	gFunctionTable_Post.pfnStartFrame = StartFrame_Post;
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

enginefuncs_t meta_engfuncs;
C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) {
	meta_engfuncs.pfnCmd_Argc = Cmd_Argc;
	meta_engfuncs.pfnCmd_Argv = Cmd_Argv;
	meta_engfuncs.pfnCmd_Args = Cmd_Args;
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return(TRUE);
}